apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
    {{ network_policy_deployment_label }}: {{ console_name }}
  name: {{ console_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ registryconsole_replicas }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ console_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ console_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ console_name }}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ console_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ console_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: HOME
          value: /var/run
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='registryconsole'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='registryconsole'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        name: console
        ports:
        - containerPort: 8080
        resources:
          limits:
            cpu: {{ registryconsole_cpu_limit }}
            memory: {{ registryconsole_memory_limit }}
          requests:
            cpu: {{ registryconsole_cpu_request }}
            memory: {{ registryconsole_memory_request }}
        volumeMounts:
        - mountPath: /certs
          name: pkiregistry
        - mountPath: /etc/nginx/conf.d/default.conf
          name: config
          subPath: default.conf
        - mountPath: /usr/share/nginx/html/index.html
          name: config
          subPath: index.html
        - mountPath: /var/cache/nginx
          name: temp
          subPath: nxcache
        - mountPath: /var/run
          name: temp
          subPath: nxrun
        - mountPath: /docker-entrypoint.d
          name: temp
          subPath: ep
{% if do_lemon or do_ldap %}
      - env:
        - name: AUTH_METHOD
{% if do_lemon %}
          value: oidc
{% else %}
          value: ldap
{% endif %}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: OIDC_CALLBACK_URL
{% if do_lemon %}
          value: /oauth2/callback
        - name: OIDC_CLIENT_ID
          value: registry
        - name: OIDC_CLIENT_SECRET
          valueFrom:
            secretKeyRef:
              key: registryconsole-oauth2-secret
              name: {{ ldap_secret_name }}
        - name: OIDC_CRYPTO_SECRET
          valueFrom:
            secretKeyRef:
              key: oidc-crypto-secret
              name: {{ console_name }}
        - name: OIDC_META_URL
          value: /.well-known/openid-configuration
        - name: OIDC_PORTAL
          value: {{ lemon_portal }}
        - name: OIDC_TOKEN_ENDPOINT_AUTH
          value: client_secret_basic
{% else %}
          value: ""
        - name: OIDC_CLIENT_ID
          value: ""
        - name: OIDC_CLIENT_SECRET
          value: ""
        - name: OIDC_CRYPTO_SECRET
          value: ""
        - name: OIDC_META_URL
          value: ""
        - name: OIDC_PORTAL
          value: ""
        - name: OIDC_TOKEN_ENDPOINT_AUTH
          value: ""
{% endif %}
        - name: OPENLDAP_BASE
{% if do_lemon %}
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
        - name: OPENLDAP_USERS_OBJECTCLASS
          value: ""
        - name: PING_PATH
          value: /ping
{% else %}
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=registry,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: registryconsole-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
        - name: OPENLDAP_USERS_OBJECTCLASS
{% if do_fusion %}
          value: gosaAccount
{% else %}
          value: {{ registryconsole_ldap_user_objectclass }}
{% endif %}
        - name: PING_PATH
          value: ""
{% endif %}
        - name: PROXY_BACKEND_HOST
          value: 127.0.0.1
        - name: PROXY_BACKEND_PORT
          value: "8080"
        - name: PROXY_BACKEND_PROTO
          value: http
        - name: PROXY_HTTP_PORT
          value: "8081"
        - name: PROXY_PROTO
          value: http
        - name: PROXY_SERVER_NAME
          value: {{ registry_fqdn }}
        - name: PUBLIC_PROTO
          value: https
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='authproxy'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='authproxy'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 30
          httpGet:
            httpHeaders:
            - name: Host
{% if do_lemon %}
              value: {{ registry_fqdn }}
            path: /ping/
{% else %}
              value: stats
            path: /
{% endif %}
            port: 8081
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 8
        name: authproxy
        ports:
        - containerPort: 8081
        readinessProbe:
          httpGet:
            httpHeaders:
            - name: Host
{% if do_lemon %}
              value: {{ registry_fqdn }}
            path: /ping/
{% else %}
              value: stats
            path: /
{% endif %}
            port: 8081
          initialDelaySeconds: 5
          periodSeconds: 20
          timeoutSeconds: 5
        resources:
          limits:
            cpu: "{{ authproxy_cpu_limit }}"
            memory: "{{ authproxy_memory_limit }}"
          requests:
            cpu: "{{ authproxy_cpu_request }}"
            memory: "{{ authproxy_memory_request }}"
        volumeMounts:
{% if (do_ldap or do_lemon) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/apache2/sites-enabled
          name: temp
          subPath: apache
        - mountPath: /etc/ssl/certs
          name: temp
          subPath: certs
        - mountPath: /usr/local/share/ca-certificates
          name: temp
          subPath: ca-certificates
        - mountPath: /usr/share/ca-certificates
          name: temp
          subPath: empty
{% if do_ldap and not do_lemon %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
{% if do_exporters %}
      - args:
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        - --scrape_uri
        - http://stats:8081/server-status
        - --telemetry.address=:9113
{% if do_triggers == False or (opsimages | json_query("[?name=='httpexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='httpexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 30
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
      hostAliases:
      - ip: 127.0.0.1
        hostnames:
        - stats
{% endif %}
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
      securityContext:
        runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ console_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - configMap:
          name: {{ console_name }}
        name: config
      - emptyDir: {}
        name: temp
{% if do_ldap and not do_lemon %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
{% if (do_ldap or do_lemon) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if registry_do_tls %}
      - name: pkiregistry
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
              name: {{ registry_name }}-cert
{% else %}
      - emptyDir: {}
        name: pkiregistry
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='registryconsole'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - console
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='registryconsole'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if (do_lemon or do_ldap) and (opsimages | json_query("[?name=='authproxy'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - authproxy
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='authproxy'].short"))[0] }}
        namespace: {{ buildns }}
{% if do_exporters and (opsimages | json_query("[?name=='httpexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='httpexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% endif %}
  - type: ConfigChange
{% endif %}
